unit CiaHtm2Txt;

{  Thanks to Bob Herbst mailto:bherbst@ezo.net who finded out how IE can
   convert Html code to plain text. I putted it in a component and let it
   execute in a separate thread.

   Just add the html code with the Add method. When the request is done
   the component fires OnRequestDone with the converted text.  }

interface

uses
  Windows, SysUtils, Classes, ComObj, ComCtrls, OleCtrls, SyncObjs;

type
  TConvertToTxt = class(TThread)
  private
    FOwner: TObject;
    FHtm: string;
    FTxt: string;
    procedure Done(Sender: TObject);
  public
    constructor Create(const S: string; Owner: TObject);
    procedure Execute; override;
  end;

type
  TCiaHtm2TxtDone = procedure(Sender: TObject; const S: string) of object;
  TCiaHtm2Txt = class(TComponent)
  private
    FOnRequestDone: TCiaHtm2TxtDone;
    procedure Done(const S: string);
  protected
  public
    procedure Add(const S: string);
  published
    property OnRequestDone: TCiaHtm2TxtDone read FOnRequestDone write FOnRequestDone;
  end;

var
   CSCiaHtm2Txt: TCriticalSection;

procedure Register;

implementation

//------------------------------------------------------------------------------
//---- TConvertToTxt -----------------------------------------------------------
//------------------------------------------------------------------------------
constructor TConvertToTxt.Create(const S: string; Owner: TObject);
begin
   inherited Create(True);       // create suspended
   FreeOnTerminate := True;
   OnTerminate := Done;
   FOwner := Owner;
   FHtm := S;
   Resume;
end;

//------------------------------------------------------------------------------
procedure TConvertToTxt.Done(Sender: TObject);
begin
   TCiaHtm2Txt(FOwner).Done(FTxt);  // this is main code (not thread)
end;

//------------------------------------------------------------------------------
procedure TConvertToTxt.Execute;
var IE, Doc, Bod, V: Variant;
begin
   CSCiaHtm2Txt.Enter;

   if InitProc <> nil then
      TProcedure(InitProc);

   IE := CreateOleObject('InternetExplorer.Application');
   IE.Navigate('about:blank', V, V, V, V);
   IE.Visible := false;

   while IE.Busy and not Terminated do
      sleep(0);

   Doc := IE.Document;
   Bod := Doc.Body;
   Bod.InnerHTML := FHtm;
   FTxt := Bod.InnerText;

   CSCiaHtm2Txt.Leave;
end;

//------------------------------------------------------------------------------
//---- TCiaHtm2Txt -------------------------------------------------------------
//------------------------------------------------------------------------------
procedure TCiaHtm2Txt.Add(const S: string);
begin
   TConvertToTxt.Create(S, Self);
end;

//------------------------------------------------------------------------------
procedure TCiaHtm2Txt.Done(const S: string);
begin
   if Assigned(FOnRequestDone) then
      FOnRequestdone(Self, S);
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('Cia', [TCiaHtm2Txt]);
end;

//------------------------------------------------------------------------------
initialization
   CSCiaHtm2Txt := TCriticalSection.Create;
finalization
   CSCiaHtm2Txt.Free;

end.
